#include "fiber.h"
#include "toric.h"
#include "parser.h"
#include "printer.h"
#include "application.h"

class FiberApplication : public CatsApplication
{
  const char *helpText()
  {
    return "This program enumerates one of the fibers of a matrix.\n"
      "The input is a matrix given in CaTS' format followed by a vector in the fiber.\n";
  }
  int main()
  {
    gbasis input=FileParser(stdin).parseMatrix();
    basis_i A=toIndexedMatrix(input);
    
    vektor_i v=FileParser(stdin).parseIntegerVector();

    assert(A.size()>0);
    assert(v.size()==A.size());
    
    gbasis g=toric1(toIndexedMatrix(input));
    
    Fiber f(g,v);
    
    AsciiPrinter p(stdout);
    f.print(p);
    
    return 0;
  }
};

FiberApplication theFiberApplication;

