#include "graver.h"
#include "toric.h"
#include "parser.h"
#include "printer.h"

#include "application.h"

class GraverApplication: public CatsApplication
{
  const char *helpText()
  {
    return "This program computes the Graver basis of a toric ideal.\n"
      "At the moment it just calls graver in 4ti2 which should be installed.\n"
      "So why write and use this program?\n"
      "- Because the output is binomials and not vectors and\n"
      "the input is in CaTS' format.\n"
      "The input is a matrix given in CaTS' format.\n";
  }
  int main()
  {
    gbasis input=FileParser(stdin).parseMatrix();
    basis_i A=toIndexedMatrix(input);
    
    GraverBasis g(A);
    gbasis g2;
    for(GraverBasis::Iterator i=g.begin();i!=g.end();++i)g2.push_back(*i);
    AsciiPrinter(stdout).printGroebnerBasisNewLine(g2);
    
    return 0;
  }
};

GraverApplication theGraverApplication;
