#include "determinant.h"
#include "parser.h"
#include "printer.h"

#include "application.h"

class MaximalMinorsApplication : public CatsApplication
{
public:
  
  MaximalMinorsApplication()
  {
    registerOptions();
  }


  const char *helpText()
  {
    return "This program computes the set of determinants of the maximal minors of a matrix. The matrix should have more columns than rows.";
  }

  
  int main()
  {
    gbasis input=FileParser(stdin).parseMatrix();

    set<int> det=determinantsOfMaximalMinors(input);

    printf("{");
    for(set<int>::const_iterator i=det.begin();i!=det.end();i++)
      {
	if(i!=det.begin())printf(", ");
	printf("%i",*i);
      }
    printf("}\n");

    return 0;
  }
};

static MaximalMinorsApplication theApplication;
