#include "parser.h"
#include "printer.h"
#include "decompose.h"

#include "application.h"

class MonomialIdeal2StandardPairsApplication : public CatsApplication
{
  const char *helpText()
  {
    return "This program is a part of CaTS. It takes an initial ideals as input and outputs its standard pairs.\n";
  }     
  
  int main()
  {
    gbasis g=FileParser(stdin).parseMonomialList(-1);
    StandardPairList s=computeStandardPairs(g);
    AsciiPrinter(stdout).printStandardPairList(s);
    
    return 0;
  }
};

static MonomialIdeal2StandardPairsApplication theApplication;

