#include "decompose.h"

#include <set>

#include "print.h"
#include "printer.h"
#include "counter.h"

static Timer standardPairTimer("StandardPair-timer"); 
static Timer standardPairTimerA("StandardPair-subtimerA"); 
static Timer standardPairTimerB("StandardPair-subtimerB"); 

bool isMinimal(vektor_i &unlimited, vektor_i &i, gbasis &m)
{
  /*  printf("Checking minimality of pair (");
  print(i);
  printf(",");
  print(unlimited);
  printf(")\n");
  */
  // check to see if there is a smaller? standard pair (1,*)

  // check to see if there is a smaller? standard pair (a,*), (b,*)....

  for(int t=0;t<unlimited.size();t++)
    {
      if(unlimited[t]==0)
	{
	  bool isAPair=true;
	  vektor_i unlimitedPrime=unlimited;
	  unlimitedPrime[t]=1;
	  // this smaller pair really a standard pair?
	  //	  printf("--");print(unlimitedPrime);
	  for(gbasis::iterator k=m.begin();k!=m.end();k++)
	    {
	      bool ok=false;
	      for(int s=0;s<unlimited.size();s++)
		{
		  if(!unlimitedPrime[s])
		    if((*k)[s]>i[s])
		      ok=true;
		}
	      if(!ok)
		{
		  isAPair=false;
		  break;
		}
	    }
	  if (isAPair) return false;
	}
    }
  return true;
}

int maxAllowable(vektor_i &unlimited, gbasis &m, vektor_i i, int j)
{
  if(unlimited[j])return 0;

  /*    printf("unlimited ");
  print(unlimited);
  printf("m ");
  print(m);
  printf("i ");
  print(i);
  printf("j %i\n",j);
  */
  int limit=1000;
  int limit2=0;


  for(gbasis::iterator k=m.begin();k!=m.end();k++)
    {
      if((*k)[j]<limit2)limit2=(*k)[j];

      if((*k)[j])
	{
	  bool givesALimit=true;
	  for(int n=0;n<k->size();n++)
	    {
	      if(n<j)
		{
		  if(!unlimited[n])
		    if((*k)[n])givesALimit=false;
		}
	      else
		if(n>j)
		  if(!unlimited[n])
		    {
		      //  printf ("n %i k[n] %i i[n] %i\n",n,(*k)[n],i[n]);
		      if((*k)[n]>i[n])
			{
			  givesALimit=false;
			  break;
			}
		    }
	    }
	  if(givesALimit)
	    {
	      if(limit>(*k)[j]-1)limit=(*k)[j]-1;
	      //  printf("-limit%i\n",(*k)[j]-1);
	    }
	  else
	    {
	      //  printf("-\n");
	    }
	}
    }

  if(limit==1000)
    {
      limit=limit2;
    }

  //    printf("limit %i\n\n",limit);
  assert(limit!=1000);

  return limit;
}

static vektor_i isStandardVector;

bool isStandard(vektor_i &unlimited, gbasis &m)
{
  //  printf("Running through matching pairs\n");
  vektor_i i(m.begin()->size());
  for(int j=0;j<i.size();j++)i[j]=0;

  do
    {
      //  printf(" ");
      //  print(i);

      if(isMinimal(unlimited, i, m))
      	{
	  isStandardVector=i;
	  return true;
	}

      int j;
      //  printf("_____________________________-pre ");
      //  print(i);
      for(j=0;j!=i.size();j++)
	{
	  if(i[j]<maxAllowable(unlimited,m,i,j))
	    {
	      i[j]++;
	      break;
	    }
	  else
	    i[j]=0;
	}
      // printf("_____________________________-post");
      // print(i);
      if(j==i.size())break;
    }
  while(1);
  
  return false;
}

bool conflicts(vektor_i &v, gbasis &m)
{
  for(gbasis::iterator j=m.begin();j!=m.end();j++)
    {
      bool ok=false;
      for(int k=0;k<j->size();k++)
	{
	  if((*j)[k]!=0)
	    {
	      if(v[k]==0)
		{
		  ok=true;
		  break;
		}
	    }
	}
      if(!ok)return true;
    }
  return false;
}

void primaryDecomposition(gbasis &monomialIdeal, gbasis *supportSet, gbasis *vectorSet)
{
  *vectorSet=gbasis();
  *supportSet=gbasis();

  vektor_i i(monomialIdeal.begin()->size());
  for(int j=0;j<i.size();j++)i[j]=0;

  do
    {
      //  printf("--------------------------------------\n");
      //  print(i);
      if(isStandard(i,monomialIdeal))
	{
	  //  printf("Found associated ideal! : ");
	  //  print(i);

	  supportSet->push_back(i);
	  vectorSet->push_back(isStandardVector);
	}

      int j;
      for(j=0;j!=i.size();j++)
	{
	  if(i[j]==1)
	    i[j]=0;
	  else
	    {
	      i[j]=1;
	      bool c=conflicts(i,monomialIdeal);
	      i[j]=0;
	      if(!c)break;
	    }
	}
      if(j==i.size())break;
      i[j]=1;
    }
  while(1);
}


gfan ass(gbasis &monomialIdeal)
{
  gfan ret;

  gbasis supportSet;
  gbasis vectorSet;

  primaryDecomposition(monomialIdeal,&supportSet,&vectorSet);

  for(gbasis::iterator i=supportSet.begin();i!=supportSet.end();i++)
    {
      gbasis associatedIdeal;

      for(int j=0;j<i->size();j++)
	if((*i)[j]==0)
	  {
	    vektor_i v(i->size());
	    v[j]=1;
	    associatedIdeal.push_back(v);
	  }
      ret.push_back(associatedIdeal);
    }

  return ret;
}


bool hasEmbeddedPrimes3(gbasis &monomialIdeal)
{
  //  assert(0);//I dont think this routine is right
  gfan ret;

  gbasis supportSet;
  gbasis vectorSet;

  primaryDecomposition(monomialIdeal,&supportSet,&vectorSet);

  for(gbasis::iterator i=vectorSet.begin();i!=vectorSet.end();i++)
    {
      //      print(*i,stderr);
      if(!i->iszero())return true;//is this right?
    }

  return false;
}


bool hasEmbeddedPrimes2(gbasis &monomialIdeal, int cc)
{
  int max=0;
  gfan ret;

  gbasis supportSet;
  gbasis vectorSet;

  gfan a=ass(monomialIdeal);

  for(gfan::iterator i=a.begin();i!=a.end();i++)
    {
      assert(i->size()>=cc);
      if(i->size()>max)max=i->size();
    }

  return max!=cc;
}

//--------------------------------------------------
// 
//--------------------------------------------------

bool StandardPair::contains(StandardPair const &d) const
{
  if(!(((d.face.support)&(~face.support))==0))return false;//d.face must divide face

  int n=root.size();
  for(int i=0;i<n;i++)
    {
      if(d.face[i]>face[i])return false;
      if(face[i]==0 && d.root[i]!=root[i])return false;
    }
  return true;
}


bool StandardPair::operator<(StandardPair const &b)const
{
  int n=root.size();
  for(int i=0;i<n;i++)
    {
      if(face[i]>b.face[i])return true;
      if(face[i]<b.face[i])return false;
    }
  for(int i=0;i<n;i++)
    {
      if(root[i]>b.root[i])return true;
      if(root[i]<b.root[i])return false;
    }
  return false;
}


typedef set<StandardPair> StandardPairSet;

StandardPairList computeStandardPairs(gbasis const &monomialIdeal)
{
  TimerScope ts0(&standardPairTimer);

  int n=monomialIdeal.begin()->size();

  StandardPairList newS;

  {
    StandardPair s;
    s.root=vektor_i(n);
    s.face=vektor_i(n);
    s.face.calcsupport();
    s.isNew=true;
    for(int i=0;i<n;i++)s.face[i]=1;
    newS.push_back(s);
  }
  for(gbasis::const_iterator i=monomialIdeal.begin();i!=monomialIdeal.end();i++)
    {
      //      printStandardPairs(newS);
      StandardPairSet tempS;
      //AsciiPrinter(stderr).printBinomial(*i);
      //fprintf(stderr,"\n");
      for(StandardPairList::const_iterator j=newS.begin();j!=newS.end();j++)
	{
	  bool intersects=true;
	  for(int k=0;k<n;k++)
	    if(j->face[k]==0 && (*i)[k]>j->root[k]){intersects=false;break;}
	  if(intersects)
	    {
	      TimerScope ts0(&standardPairTimerA);

	      for(int k=0;k<n;k++)
		if(j->face[k])
		  {
		    for(int l=0;l<(*i)[k];l++)
		      {
			StandardPair s;
			s.root=j->root;
			s.root[k]=l;
			s.face=j->face;
			s.face[k]=0;
			s.face.calcsupport();
			s.isNew=true;
			tempS.insert(s);
		      }
		  }
	    }
	  else
	    tempS.insert(*j);
	}
      newS=StandardPairList();

      {
	TimerScope ts0(&standardPairTimerB);
	for(StandardPairSet::const_iterator j=tempS.begin();j!=tempS.end();j++)
	  {
	    bool minimal=true;
	    if(j->isNew)
	      {
		for(StandardPairSet::const_iterator k=tempS.begin();k!=tempS.end();k++)
		  {
		    if(j!=k && k->contains(*j)){minimal=false;break;}
		  }
	      }
	    j->setIsNew(false); 
	    if(minimal)
	      newS.push_back(*j);
	  }
      }
    }
  //  printStandardPairs(newS);
  return newS;
}


static int numberOfNonZeros(vektor_i const &v)
{
  int ret=0;
  int n=v.size();
  for(int i=0;i<n;i++)
    if(v.v[i])ret++;
  return ret;
}


bool hasEmbeddedPrimes(gbasis const &monomialIdeal)
{
  StandardPairList s=computeStandardPairs(monomialIdeal);

  //  AsciiPrinter(stdout).printStandardPairList(s);

  if(s.begin()!=s.end())
    {
      int d=numberOfNonZeros(s.begin()->face);
      for(StandardPairList::const_iterator i=s.begin();i!=s.end();i++)
	{
	  if(d!=numberOfNonZeros(i->face))return true;
	}
    }
  return false;
}
