#include "determinant.h"
#include <assert.h>
#include "printer.h"

//--------------------------------------------------
// determinant - very slow recursive implementation
//--------------------------------------------------

int determinant(const gbasis &m)
{
  assert(m.begin()!=m.end());
  assert(m.begin()->size()==m.size());

  int n=m.size();
  if(n==1)
    return (*m.begin())[0];

  int sum=0;
  int sign=1;

  for(int i=0;i<n;i++)
    {
      if((*m.begin())[i])
	{
	  gbasis m2;
	  gbasis::const_iterator b=m.begin();
	  b++;
	  for(;b!=m.end();b++)
	    {
	      vektor_i v(n-1);
	      int j=0;
	      for(;j<i;j++)
		v[j]=(*b)[j];
	      for(;j<n-1;j++)
		v[j]=(*b)[j+1];
	      m2.push_back(v);
	    }
	  
	  sum+=sign*(*m.begin())[i]*determinant(m2);
	}
      sign*=-1;
    }
  return sum;
}


set<int> determinantsOfMaximalMinors(const gbasis &m)
{
  int nperm=0;
  set<int> ret;

  list<int> permutation;

  int n=m.size();
  assert(n!=0);
  int d=m.begin()->size();

  assert(n>=d);
  for(int i=0;i<n-d;i++)permutation.push_back(0);
  for(int i=0;i<d;i++)permutation.push_back(1);
  
  do
    {
      gbasis m2;
      list<int>::const_iterator J=permutation.begin();
      for(gbasis::const_iterator j=m.begin();j!=m.end();j++)
	{
	  if(*J)m2.push_back(*j);
	  J++;
	}
      ret.insert(determinant(m2));
      nperm++;
    }
  while(next_permutation(permutation.begin(),permutation.end()));
  
  //  fprintf(stderr,"number of subsets:%i\n",nperm);

  return ret;
}
