#include "division.h"
#include "print.h"
#include "printer.h"
#include "counter.h"

#define SUPPORTVECTOR 1

static Timer autoreductionTimer("Autoreduction-timer"); 
static Timer minimalisingTimer("Minimising-timer"); 


void division(vektor_i *v, const gbasis& b)
{
  gbasis::const_iterator i=b.begin();

  if(v->iszero())return;

  v->order();
  v->calcsupport();
  while(i!=b.end())
  {
    // if(v->reduce(*i))
    if(((((i->support)&(~v->support))==0)||(!SUPPORTVECTOR))&&(v->reduce(*i)))
      {
	//v->order();
	v->calcsupport();
	//	while(v->reduce(*i));
	i=b.begin();
	if(v->iszero())return;
      }
    else i++;
  }
    *v=-1* *v;
  v->calcsupport();
  i=b.begin();
  while(i!=b.end())
  {
    // if(v->reduce(*i))
    if(((((i->support)&(~v->support))==0)||(!SUPPORTVECTOR))&&(v->reduce(*i)))
//    if((((i->support)&(~v->support))==0)&&(v->reduce(*i)))
      {
	//	v->order();
	v->calcsupport();
	//while(v->reduce(*i));
	i=b.begin();
	if(v->iszero())return;
      }
    else i++;
    }
  v->order();
    v->calcsupport();
  


  //printf("\n");
}


//used in flip: 
void division_(vektor_i *v, const gbasis& b)
{
  // reduces a monomial with respect to a marked basis
  gbasis::const_iterator i=b.begin();

  if(v->iszero())return;

  //  v->order();
  v->calcsupport();
  while(i!=b.end())
  {
    if(((((i->support)&(~v->support))==0)||(!SUPPORTVECTOR))&&(v->reduce(*i)))
      {
	//	AsciiPrinter(stderr).printMonomial(*v);fprintf(stderr," ");
	v->calcsupport();
	i=b.begin();
	if(v->iszero())return;
      }
    else i++;
  }
  v->calcsupport();
} 

void gbasissort(gbasis *b)
{
  b->sort();
}


class ltcmp
{//noedvendigt at lave ny cmp funktion! den gamle sammenlignede ikke kun lt
public:
bool operator()(const vektor_i& a,const vektor_i& b) const
{
  for(int i=0;i<a.size();i++)
    {
      if(b[i]>0)if(a[i]<b[i])return true;
      if(a[i]>0)if(a[i]>b[i])return false;
    }
  return false;
}
};

static ltcmp ltcmp2;


void gbasisminimal(gbasis *a)
{
  TimerScope ts0(&minimalisingTimer);

  gbasis ret;

  a->sort(ltcmp2);//tilfojet 15. maj 2002

  for(gbasis::iterator i=a->begin();i!=a->end();i++)
    {
      bool del=false;
      for(gbasis::iterator j=ret.begin();j!=ret.end();j++)
	{
	  if(j->divides(*i))
	    {
	      del=true;
	      break;
	    }
	}
      if(!del)
	if(!i->iszero())
	  ret.push_back(*i);
    }
  *a=ret;
}


static inline bool dividestl(const vektor_i& i, const vektor_i& j)
{
  int n=i.size();
  for(int t=0;t<n;t++)if(i.v[t]>0)if(i.v[t]>-(j.v[t]))return false;
  return true;
}

void gbasisautoreduction(gbasis *b)
{
  TimerScope ts0(&autoreductionTimer);

  for(gbasis::iterator j=b->begin();j!=b->end();j++)
    for(gbasis::iterator i=b->begin();i!=b->end();i++)
      {
      r:
	if(!i->iszero())
	  {
	    if(dividestl(*i,*j))
	      {
		while(dividestl(*i,*j))*j+=*i;
		i=b->begin();goto r;
	      }
	  }
      }
}


bool isLeadingTermInInitialIdeal(const vektor_i &v, const gbasis &b)
{
  for(gbasis::const_iterator i=b.begin();i!=b.end();i++)
    {
      if(i->divides(v))return true;
    }

  return false;
}
