#ifndef EA_EXHAUSTIVE_H_INCLUDED
#define EA_EXHAUSTIVE_H_INCLUDED

#include "enumeration.h"
#include "graver.h"

class ExhaustiveSearch: public EnumerationAlgorithm
{
 protected:
  bool allFlipable;
  bool useOrdered;
  virtual bool insertionTest(const vektor_i &e){return true;}
  virtual bool flipable(const vektor_i &v);
  virtual gbasis myFlip(const gbasis& g, const vektor_i& p);
  virtual gbasis findRoot(gbasis const &g);
 public:
  ExhaustiveSearch():useOrdered(true),allFlipable(false){}
  void setUseOrdered(bool useOrdered){this->useOrdered=useOrdered;}
  void setAllFlipable(bool allFlipable){this->allFlipable=allFlipable;}
  void enumerate(gbasis g);
};

class ExhaustiveSearchAGraded: public ExhaustiveSearch
{
  bool useGraverBasis;
  gbasis trueGroebnerBasis;
  GraverBasis graver;
 public:
  ExhaustiveSearchAGraded(const gbasis &trueGroebnerBasis);//use fiber search
  ExhaustiveSearchAGraded(const basis_i &A);//use graver basis
  virtual gbasis myFlip(const gbasis& g, const vektor_i& p);
};

#endif
