#include "ea_exhaustiveradical.h"
#include "division.h"
#include "radical.h"
#include "walk.h"

gbasis ExhaustiveSearchFixedRadical::findRoot(gbasis const &g)
{
  return walkFixedRadical(g);
}


void ExhaustiveSearchFixedRadical::enumerate(gbasis g)
{
  setUseOrdered(false);//this should not be necessary if we are able to find a term order for the root????
  gbasissort(&g);
  radical=initialradical(g);
  ExhaustiveSearch::enumerate(g);
  result->numberOfEdges.assign(-1);
}


bool ExhaustiveSearchFixedRadical::insertionTest(const vektor_i &e)
{
  return !flipsToOtherRadical(radical,e);
}


gbasis ExhaustiveSearchAGradedFixedRadical::findRoot(gbasis const &g)
{
  return g;
}


void ExhaustiveSearchAGradedFixedRadical::enumerate(gbasis g)
{
  setUseOrdered(false);
  gbasissort(&g);
  radical=initialradical(g);
  ExhaustiveSearchAGraded::enumerate(g);
  result->numberOfEdges.assign(-1);
}


bool ExhaustiveSearchAGradedFixedRadical::insertionTest(const vektor_i &e)
{
  return !flipsToOtherRadical(radical,e);
}
