#include "ea_reverse.h"
#include "division.h"
#include "flip.h"
#include "lp.h"
#include "facet.h"
#include "walk.h"
#include "printer.h"

gbasis ReverseSearch::findRoot(gbasis const &g)
{
  return walk(g);
}


ReverseSearch::ReverseSearch():
  numberOfEdges(0),
  numberOfVertices(0)
{
}

bool ReverseSearch::isOutgoing(gbasis &h, const vektor_i &mi)
{
  h.sort(ltcmp2); //alligevel ikke fjernet 17. maj 2002

  for(gbasis::iterator j=h.begin();j!=h.end();j++)
    {
      if(!j->ordered())
	{
	  if((mi-*j).iszero())return true;
	  if(isAlgebraicFacet(h,j))
	    if(isfacet(h,j))return false;
	}
    }
  assert(0);
  return false;
}


bool ReverseSearch::edgeTest(const vektor_i &e)
{
  return e.ordered();
}


int ReverseSearch::treeSize(const gbasis &g)
{
  int ts=1;

  if(!targetBasis(g))
    {
      breaked=true;
      return ts;
    }

  gbasis irr=irredundant(g);

  for(gbasis::iterator i=irr.begin();i!=irr.end();i++)
    if(edgeTest(*i))
      {
	bool largest=true;
	numberOfEdges++;
	gbasis h=flip(g,*i);
	gbasisautoreduction(&h);
	vektor_i mi=-*i;
	if(isOutgoing(h,mi))
	  {
	    ts+=treeSize(h);
	    if(breaked)break;
	  }
      }
  return ts;
}


void ReverseSearch::enumerate(gbasis g)
{
  numberOfVertices=0;
  numberOfEdges=0;

  g=findRoot(g);

  breaked=false;
  targetBeginEnumeration(g);

  numberOfVertices=treeSize(g);

  result->numberOfVertices.assign(numberOfVertices);
  result->numberOfEdges.assign(numberOfEdges);

  targetEndEnumeration();
}

