#include "ea_reverseradical.h"
#include "radical.h"
#include "facet.h"
#include "lp.h"
#include "walk.h"

gbasis ReverseSearchFixedRadical::findRoot(gbasis const &g)
{
  gbasis g2=walk(g);
  
  gbasis r1=initialradical(g);
  gbasis r2=initialradical(g2);

  if(!areEqual(&r1,&r2))
    {
      fprintf(stderr,"We can only do reverse search with fixed radical if the term order corresponds to the radical.\n");
      assert(0);
    }

  return g2;
}


bool ReverseSearchFixedRadical::isOutgoing(gbasis &h, const vektor_i &mi)
{
  gbcmp CMP;

  h.sort(ltcmp2); //alligevel ikke fjernet 17. maj 2002

  for(gbasis::iterator j=h.begin();j!=h.end();j++)
    {
      if(!j->ordered())
	{
	  if((mi-*j).iszero())return true;
	  if(isAlgebraicFacet(h,j))
	    if(isfacet(h,j))
	      {
		//check radical
		gbasis radical2=initialradical(flip(h,*j));
		if((!CMP(radical,radical2))&&(!CMP(radical2,radical)))
		  return false;
	      }
	}
    }
  assert(0=="Did you remember to minimalize and autoreduce after calling Buchberger?");
  return false;
}

bool ReverseSearchFixedRadical::edgeTest(const vektor_i &e)
{
  return(e.ordered() && !flipsToOtherRadical(radical,e));
}

void ReverseSearchFixedRadical::enumerate(gbasis g)
{
  radical=initialradical(g);
  ReverseSearch::enumerate(g);
  result->numberOfEdges.assign(-1);
}
