#include "enumeration.h"
#include <cassert>


EnumerationFilePrinter::EnumerationFilePrinter():
  initialisedFile(0),
  file(0),
  filename("")
{
}


EnumerationFilePrinter::~EnumerationFilePrinter()
{
  assert(file==0);
}


void EnumerationFilePrinter::open(string filename)
{
  this->filename=filename;
  string name=filename+extension();
  initialisedFile=fopen(name.c_str(),"w");
  file=initialisedFile;

  assert(file);

  fprintf(stderr,"Output file opened: \"%s\"\n",name.c_str());

  onOpened();
}


void EnumerationFilePrinter::open(FILE *file)
{
  initialisedFile=0;
  this->file=file;

  assert(file);

  onOpened();
}


void EnumerationFilePrinter::close()
{
  onClose();

  if(initialisedFile)
    {
      fclose(initialisedFile);
      onClosed();
      initialisedFile=0;
    }
  file=0;
}


string EnumerationFilePrinter::extension()
{
  return "";
}


void EnumerationAlgorithm::printProgress(int step)
{
  while(step>0)
    {
      progressCounter++;
      if(!(progressCounter&4095))
	//      if(!(progressCounter&255))
	fprintf(stderr,"Number of Gr\"obner Bases found %i\n",progressCounter);
      fflush(stderr);
      step--;
    }
}
