#include "ep_latex.h"
#include "print.h"
#include "printer.h"


LatexEnumerationPrinter::LatexEnumerationPrinter():
  printer(0)
{
}


void LatexEnumerationPrinter::onOpened()
{
  fprintf(file,"\\documentclass[12pt,a4paper,dvips]{article}"
	  "\\usepackage[english]{babel}"
	  "\\usepackage{t1enc}"
	  "\\usepackage{a4}"
	  "\\usepackage{epsfig}"
	  "\\usepackage{amsfonts}"
	  "\\usepackage{latexsym}"
	  "\\begin{document}\n");
  printer = new LatexPrinter(file);
}


void LatexEnumerationPrinter::onClose()
{
  delete printer;
  printer=0;
  fprintf(file,"\\end{document}");
}


void LatexEnumerationPrinter::onClosed()
{
  string command="latex "+filename+">/dev/null";
  system(command.c_str());
}


void LatexEnumerationPrinter::beginEnumeration(const gbasis &g)
{
  basisCounter=0;
}


void LatexEnumerationPrinter::endEnumeration()
{
}


void LatexEnumerationPrinter::beginRadical(const gbasis& radical, int numberOfSymmetries)
{
}


void LatexEnumerationPrinter::endRadical()
{
}


bool LatexEnumerationPrinter::basis(const gbasis &g)
{
  fprintf(file, "Printing basis no. %i:\n\n", basisCounter++);
  printer->printGroebnerBasis(g);
  fprintf(file, "\n\n");

  return true;
}


string LatexEnumerationPrinter::extension()
{
  return "tex";
}
