#ifndef EP_TIGERS_H_INCLUDED
#define EP_TIGERS_H_INCLUDED

#include "enumeration.h"
#include "printer.h"

class TigersEnumerationPrinter: public EnumerationFilePrinter
{
  int basisCounter;
  int radicalCounter;
  int firstBasisInThisRadical;
  int numberOfBegins;
  bool insertComma;
  Printer *printer;
  bool initialIdealPrinting;
  bool stripPrinting;
public:
  TigersEnumerationPrinter();
  void initialIdealPrintingSetEnabled(bool enabled);
  void stripPrintingSetEnabled(bool enabled);
  void beginEnumeration(const gbasis &g);
  void endEnumeration();
  void beginRadical(const gbasis &radical, int numberOfSymmetries=0);
  void endRadical();
  bool basis(const gbasis &g);
  string extension();
  void onOpened();
  void onClose();
  void onClosed();
};

#endif
