#ifndef FIBER_H_INCLUDED
#define FIBER_H_INCLUDED

#include "vektor.h"
#include "printer.h"

class Fiber
{
  const gbasis g;
  vektor_i rootElement;
 public:
  class Iterator
    {
      const gbasis *g;
      struct StackElement{
	vektor_i v;
	gbasis::const_iterator i;
      };
      list<StackElement> stack;
    protected:
      Iterator(const gbasis &gb, const vektor_i rootElement);
      bool isEdge(const vektor_i &v, gbasis::const_iterator &i);
    public:
      Iterator(){};
      bool operator==(const Iterator &b){return stack.empty();}//can only be compared to end
      bool operator!=(const Iterator &b){return !operator==(b);};
      bool operator++();
      const vektor_i& operator*();
      friend class Fiber;
      void printStack();
    };
  Fiber(const gbasis &gb, const vektor_i &fiberElement);
  Iterator begin();
  Iterator end();
  void print(Printer &p);
};

void liftUsingFiber(gbasis *gLifting, const gbasis &g);

#endif
