#include "graver.h"

#include <stdio.h>
#include <assert.h>
#include <string>

#include "programs.h"
#include "printer.h"

//#define DEF4ti2 "4ti2"
#define DEF4ti2Input "4ti2Input"


void GraverBasis::MatchIterator::begin(GraverElementList const &l, const vektor_i &a)
{
  iBegin=l.lower_bound(a);

  iEnd=l.upper_bound(a);




  //  if(iBegin!=iEnd)fprintf(stderr,"More than one graver element with this leading term\n");
  //  iEnd++;
  
  /*fprintf(stderr,"Matching:\n");
  AsciiPrinter(stderr).printMonomial(a);
  fprintf(stderr,"\n");

    if(iBegin!=l.end())
    {
      fprintf(stderr,"MatchBegin\n");
      AsciiPrinter(stderr).printBinomial(*iBegin);
    }
  if(iBegin!=l.end())
    {
      fprintf(stderr,"\nMatchEnd\n");
      AsciiPrinter(stderr).printBinomial(*iEnd);
      fprintf(stderr,"\n");
    }
  */
  i=iBegin;
}

GraverBasis::GraverBasis(const basis_i &A, bool areLatticeGenerators)
{
  // compute Graver Basis


  // We use 4ti2 for this using files. Since 4ti2 exchanges row and column number we cannot use printer.h for generating the input file

  system("rm "DEF4ti2Input);
  system("rm "DEF4ti2Input".lat");
  system("rm "DEF4ti2Input".gra");

  char *filename;
  if(areLatticeGenerators)
    filename=DEF4ti2Input".lat";
  else
    filename=DEF4ti2Input;

  FILE *f=fopen(filename,"w");
  assert(f);

  //  fprintf(f,"%i %i \n",A.size(),A[0].size());
  fprintf(f,"%i %i \n",A[0].size(),A.size());//but changed order again in version 1.1
  for(int i=0;i<A[0].size();i++)
    {
      for(int j=0;j<A.size();j++)
      {
	fprintf(f,"%i ",A[j][i]);
      }
      fprintf(f,"\n");
    }

  fclose(f);

  fprintf(stderr,"Starting 4ti2 graver\n");
  string test=(string(programName4ti2Graver)+string(" " DEF4ti2Input));
  fprintf(stderr,test.c_str());
  system(test.c_str());
  //  system((string(programName4ti2Graver)+(areLatticeGenerators?string(" lat"):string(""))+string(" " DEF4ti2Input">/dev/null")).c_str());
  //  system(DEF4ti2 "/graver " DEF4ti2Input);

  f=fopen(DEF4ti2Input".gra","r");

  assert(f);

  {
    int dummy;
    fscanf(f,"%i %i",&dummy,&dummy);
  }

  int n=A.size();
  while(!feof(f))
    {
      vektor_i v(n);

      for(int i=0;i<n;i++)
	{
	  int temp;
	  if(feof(f))break;
	  fscanf(f,"%i",&temp);
	  v[i]=temp;
	}
      if(feof(f))break;
      gList.insert(v);
      gList.insert(-v);

      /*      fprintf(stderr,"Adding:\n");
      AsciiPrinter(stderr).printBinomial(v);
      fprintf(stderr,"\n");
      fprintf(stderr,"Adding:\n");
      AsciiPrinter(stderr).printBinomial(-v);
      fprintf(stderr,"\n");
      */
    }
  fclose(f);
} 


GraverBasis::MatchIterator GraverBasis::matchBegin(const vektor_i &a)
{
  MatchIterator ret;
  ret.begin(gList,a);
  return ret;
}


GraverBasis::MatchIterator GraverBasis::matchEnd()
{
  MatchIterator ret;
  return ret;
}

void GraverBasis::print(FILE *f)
{
  fprintf(f,"Graver Basis:");
  for(GraverElementList::iterator i=gList.begin();i!=gList.end();i++)
    {
      AsciiPrinter(f).printBinomial(*i);
      fprintf(f,"\n");
    }
  fprintf(f,"end of Graver Basis\n");
}
