#ifndef GRAVER_H_INCLUDED
#define GRAVER_H_INCLUDED

#include "vektor.h"
#include <set> 

class GraverBasis{
  struct CompareClass
  {
    bool lex(vektor_i const &a, vektor_i const &b) const
    {
      assert(a.size()==b.size());
      for(int i=0;i<a.size();i++)
	{
	  if(a[i]>b[i])return false;
	  if(a[i]<b[i])return true;
	}
      return false;
    }
    bool operator()(vektor_i const &a, vektor_i const &b) const
    {
      if(lex(a.lt(),b.lt()))return true;
      if(lex(b.lt(),a.lt()))return false;
      //	return a.leadingTermLess(b);
	// else
      return false;
      //      return lex(a,b);
   }
  };

  typedef multiset<vektor_i, CompareClass> GraverElementList;
  GraverElementList gList;
 public:
  typedef GraverElementList::iterator iterator;
  typedef iterator Iterator;//I should use capital letters for this....
  iterator begin(){return gList.begin();}
  iterator end(){return gList.end();}
  GraverBasis(){}
  GraverBasis(const basis_i &A, bool areLatticeGenerators=false);
  class MatchIterator
    {
      GraverElementList::const_iterator i;
      GraverElementList::const_iterator iBegin;
      GraverElementList::const_iterator iEnd;
      void begin(GraverElementList const &l, const vektor_i &a);
    public:
      void operator++(){i++;}
      bool operator==(MatchIterator const &b){return i==iEnd;}//you can only compare it to iEnd 
      bool operator!=(MatchIterator const &b){return !(operator==(b));}
      vektor_i operator*(){return *i;}
      friend class GraverBasis;
    };
  MatchIterator matchBegin(const vektor_i &a);
  MatchIterator matchEnd();
  void print(FILE *f);
  friend class MatchIterator;
};

#endif
