#include "latticeideal.h"

#include <assert.h>

#include "graver.h"
#include "division.h"
#include "lll.h"
#include "buchberger.h"
#include "printer.h"

//Version using graver

gbasis latticeIdeal(basis_i const &latticeGenerators)
{
  gbasis ret;

  GraverBasis g(latticeGenerators,true);
  for(GraverBasis::Iterator i=g.begin();i!=g.end();++i)
    if(i->ordered())ret.push_back(*i);
  gbasisminimal(&ret);
  gbasisautoreduction(&ret);

  return ret;
}


//Version without graver - not working
/*
gbasis latticeIdeal(basis_i const &latticeGenerators)
{
  assert(latticeGenerators.size()>0);
  int dim=latticeGenerators[0].size();
  basis_i M1(latticeGenerators.size());
  for(int i=0;i<latticeGenerators.size();i++)M1[i]=latticeGenerators[i];
  
  mlll(M1);

  gbasis MMM(latticeGenerators.size());
  copy(M1.begin(),M1.end(),MMM.begin());

  for(int i=0;i<dim;i++)
    {
      vektor_i::TERMORDER=REVERSELEXICOGRAPHIC;
      vektor_i::setcheapest(i);
      buchberger(MMM);
      gbasisminimal(&MMM);
      gbasisautoreduction(&MMM);
    }


  return MMM;
}
*/
