#ifndef LP_H_INCLUDED
#define LP_H_INCLUDED

#include <stdio.h>

#include "vektor.h"
#include "print.h"

extern int lp_status;
extern bool lp_soplexlinked;

int isfacet(const gbasis &g, gbasis::const_iterator i);
void setSubsetEnabled(bool enabled);
void setSoplexEnabled(bool enabled);
bool lpSetSolver(const char *name);

class LpSolver
{
  static class LpSolver *list;
  class LpSolver *next;
 public:
  LpSolver();
  static LpSolver *find(const char *name);
  static void printList(FILE *f);
  virtual bool isFacet(const gbasis &g, gbasis::const_iterator i)=0;
  virtual const char *name()=0;
};


#endif
