#include "lp_huber.h"
#include "Rsimp.h"


static int isirredundant_huberthomas(const gbasis &g, gbasis::const_iterator i)
{//returns true if facet binomial
  bool found1,found=false;
  
  {
#define M_ 40
#define N_ 1000
    int ret;
    int n,m;
    static double A_[N_][M_];
    static double *A[N_];
    static double R_[N_][M_];
    static double *R[N_];
    static double Q_[N_][M_];
    static double *Q[N_];
    static double b[M_];
    static double c[N_];
    static double x[N_];
    static int basis[M_];
    static int nonbasis[N_];
    static double t1[M_+N_];
    static double t2[M_+N_];
    
    
    int D=i->size();
    int M=g.size();
    
    // højde m
    // bredde n
    
    
    
    //m=i->size();
    //n=m+2*g.size();
    
    assert(D<=M_);
    assert(D+2*M<=N_);
    
    for(int j=0;j<D+2*M;j++)A[j]=&(A_[j][0]);
    for(int j=0;j<D+2*M;j++)R[j]=&(R_[j][0]);
    for(int j=0;j<D+2*M;j++)Q[j]=&(Q_[j][0]);
    int idx=0;
    for(gbasis::const_iterator j=g.begin();j!=g.end();j++)
      {
	for(int row=0;row<D;row++)
	  A_[row][idx]=j->v[row];
	if(j==i)
	  for(int row=0;row<D;row++)
	    A_[row][idx]*=-1;
	for(int row=D;row<D+2*M;row++)
	  A_[row][idx]=0;
	A_[D+M+idx][idx]=1;
	A_[D+idx][idx]=-1;
	b[idx]=1;
	idx++;
      }
    for(int row=0;row<D+M;row++)
      {
	c[row]=0;
	x[row]=0;
	nonbasis[row]=row;
      }
    for(int row=0;row<M;row++)
      {
	c[D+M+row]=1;
	x[D+M+row]=1;
	basis[row]=D+M+row;
      }
    
    ret=Rsimp(M,D+2*M,A,b,c,x,basis,nonbasis,R,Q,t1,t2);
    
    switch(ret)
      {
      case LP_FAIL:
	fprintf(stderr,"Simplex algorithm fails222!!\n");
	printf("Simplex algorithm fails222!!\n");
	//  return 0;
	//  return 1;
	//  break;
      case LP_UNBD:
	//  break;
      case LP_OPT:
	int f=1;
	for(int k=0;k<M;k++)if(basis[k]>=M+D)
	  {
	    //if(x[basis[k]]>0.001)
	    f=0;
	    break;
	  }
	if(f==0)
	  {
	    return 0;
	  }
	break;
      }
  }
  return 1;
}


bool LpSolverHuber::isFacet(const gbasis &g, gbasis::const_iterator i)
{
  return isirredundant_huberthomas(g, i);
}

static LpSolverHuber theLpSolverHuber;
