#include "result.h"
#include <iomanip>

using namespace std;

ResultList IntegerResult::resultList;

void IntegerResult::registerThis()
{
  resultList.push_back(this);  
}


ResultList IntegerResult::getAndClearRegisteredResultList()
{
  ResultList r=resultList;
  resultList=ResultList();

  return r;
}

void IntegerResult::print(std::ostream &f)
{
  f<<setw(20) << name <<":";
  f<<setw(8)<<value;
  f<<"\n";
}

Result::Result():
  time("Time"),
  dDimension("Dimension"),
  nDimension("Dimension"),
  kernalDimension("Dimension"),
  sizeOfGrLexBasis("GRlex_gbasis_size"),
  sizeOfLexBasis("Lex_gbasis_size"),
  numberOfVertices("Graph_vertices"),
  numberOfEdges("Graph_edges")
{
  resultList=IntegerResult::getAndClearRegisteredResultList();
}


void Result::fillOutBasicFields(const basis_i &A)
{
  nDimension.assign(A.size());
  dDimension.assign(A.begin()->size());
}


void Result::print(std::ostream &f)
{
  for(ResultList::iterator i=resultList.begin();i!=resultList.end();i++)
    {
      (*i)->print(f);
    }
}

void Result::save(const std::string &filename)
{
  ofstream f(filename.c_str(),ios_base::out);
  print(f);
}
