#ifndef RESULT_H_INCLUDED
#define RESULT_H_INCLUDED

#include <list>
#include <fstream>

#include "vektor.h"

typedef std::list<class IntegerResult*> ResultList;

class IntegerResult
{
  int value;
  bool hasValue;
  const char *name;
  static ResultList resultList;
  void registerThis();
 public:
  IntegerResult(const char *name):
    value(-1),
    hasValue(false),
    name(name)
    {
      registerThis();
    }
  void assign(int value)
    {
      this->value=value;
      hasValue=true;
    }
  void print(std::ostream &f);
  int get(){return value;}
  static ResultList getAndClearRegisteredResultList();
};

class Result
{
  ResultList resultList;
 public:
  // Time
  IntegerResult time;
  // Dimensions
  IntegerResult dDimension;
  IntegerResult nDimension;
  IntegerResult kernalDimension;
  // Sizes Of Specific Groebner Bases
  IntegerResult sizeOfGrLexBasis;
  IntegerResult sizeOfLexBasis;
  // State Polytope
  IntegerResult numberOfVertices;
  IntegerResult numberOfEdges;
  
  Result();

  void fillOutBasicFields(const basis_i &A);
  void print(std::ostream &f);
  void save(const std::string &filename);
};

#endif
