#include "vektor.h"

int numberofvektors=0;
int maxnumberofvektors=0;

int vektor_f::mixedelimk;
int vektor_f::cheaptable[MAXNUMBEROFVARIABLES];
int vektor_f::TERMORDER;
int vektor_f::cheapest;
bool vektor_f::weightenable;
vektor_f vektor_f::weight;
bool vektor_f::weight_double_enable;
vektor<double> vektor_f::weight_double;
int vektor_i::mixedelimk;
int vektor_i::cheaptable[MAXNUMBEROFVARIABLES];
int vektor_i::TERMORDER;
int vektor_i::cheapest;
bool vektor_i::weightenable;
vektor_i vektor_i::weight;
bool vektor_i::weight_double_enable;
vektor<double> vektor_i::weight_double;



basis_f tobasis_f(const basis_i& i)
{
  basis_f f(i.size());
  for(int j=0;j<i.size();j++)f[j]=i[j];
  return f;
}

basis_i tobasis_i(const basis_f& i)
{
  basis_i f(i.size());
  for(int j=0;j<i.size();j++)f[j]=(i[j]);
  return f;
}


basis_i randommatrix_i(int rows, int cols, int max)
{
  basis_i f(cols);
  for(int j=0;j<cols;j++)
    {
      f[j]=vektor_i(rows);

      for(int i=0;i<rows;i++)
	f[j][i]=((int)rand()&0x7fff)%max;
    }
  return f;
}


gbasis initialIdeal(const gbasis &g)
{
  gbasis ret;
  for(gbasis::const_iterator i=g.begin();i!=g.end();i++)
    ret.push_back(i->lt());

  return ret;
}


basis_i toIndexedMatrix(gbasis m)
{
  basis_i ret;

  for(gbasis::iterator i=m.begin();i!=m.end();i++)
    {
      ret.push_back(*i);
    }

  return ret;
}


gbasis toLinkedMatrix(basis_i m)
{
  gbasis ret;

  for(basis_i::iterator i=m.begin();i!=m.end();i++)
    {
      ret.push_back(*i);
    }

  return ret;
}


basis_i transposeMatrix(const basis_i &m)
{
  basis_i M(m[0].size());

  for(int i=0;i<m[0].size();i++)
    {
      M[i]=vektor_i(m.size());
      for(int j=0;j<m.size();j++)
	M[i][j]=m[j][i];
    }

  return M;
}


bool isGraded(const gbasis &g)
{
  for(gbasis::const_iterator i=g.begin();i!=g.end();i++)
    {
      if(i->sum()!=0)return false;
    }

  return true;
}

class sortLexCmp
{//noedvendigt at lave ny cmp funktion! den gamle sammenlignede ikke kun lt
public:
bool operator()(const vektor_i& a,const vektor_i& b) const
{
  for(int i=0;i<a.size();i++)
    {
      if(b[i]>0)if(a[i]<b[i])return false;
      if(a[i]>0)if(a[i]>b[i])return true;
    }
  return false;
}
};

static sortLexCmp ltcmp2;

void sortLex(gbasis *g)
{
  g->sort(ltcmp2);
}


int degree(const gbasis &monomialIdeal)
{
  int ret=0;
  for(gbasis::const_iterator i=monomialIdeal.begin();i!=monomialIdeal.end();i++)
    {
      int d=0;
      for(int j=0;j<i->size();j++)if((*i)[j]>0)d+=(*i)[j];
      if(d>ret)ret=d;
    }
  return ret;
}


bool areEqual(gbasis *g, gbasis *h)
{
  sortLex(g);
  sortLex(h);
  gbasis::const_iterator i=g->begin();
  gbasis::const_iterator j=h->begin();
  while((i!=g->end())&&(j!=h->end()))if(*(j++)!=*(i++))return false;
  return (i==g->end())==(j==h->end());
}














