#include "walk.h"
#include "facet.h"
#include "lp.h"
#include "printer.h"
#include "radical.h"

//-----------------------------------------------------------------
// Groebner Walk
//-----------------------------------------------------------------

gbasis walk(gbasis const &start)
{
  gbasis g=start;
 loop:
  {
    gbasis temp=algebraicFacets(g);
    
    for(gbasis::const_iterator i=temp.begin();i!=temp.end();i++)
      {
	if(!(i->ordered()))if(isfacet(temp,i))
	  {
            //	    fprintf(stderr,"flipping!\n");
	    g=flip(g,*i);
	    gbasisminimal(&g);
	    gbasisautoreduction(&g);
            //	    printf("\nFlip to basis with %i elements.\n\n",g.size());
	    //print_time();
	    //	printt(g);
	    //fflush(stdout);
	    goto loop;//i=g.begin();
	  }
      }
  }
  return g;
}

//-----------------------------------------------------------------
// Groebner Walk - fixed radical
//-----------------------------------------------------------------

gbasis walkFixedRadical(gbasis const &start)
{
  gbasis g=start;
  gbasis radical=initialradical(g);
  //  fprintf(stderr,"testestestspping!\n");
 loop:
  {
    gbasis temp=algebraicFacets(g);
    
    for(gbasis::const_iterator i=temp.begin();i!=temp.end();i++)
      {
	//fprintf(stderr,"\nAlgebraic facets\n:");
	//AsciiPrinter(stderr).printGroebnerBasis(temp);
	if(!(i->ordered()))
	  if(!flipsToOtherRadical(radical, *i))
	    if(isfacet(temp,i))
	      {
		//fprintf(stderr,"flipping!\n");
		g=flip(g,*i);
		gbasisminimal(&g);
		gbasisautoreduction(&g);
		//printf("\nFlip to basis with %i elements.\n\n",g.size());
		//print_time();
		//	printt(g);
		//fflush(stdout);
		goto loop;//i=g.begin();
	      }
      }
  }
  return g;
}

